#!/usr/bin/perl
# $Id: ivhtml_tex.pl,v 1.12 2009/11/04 09:46:17 skoch Exp $

use AFM;

my $debug = 0;
for my $string (@ARGV) {
    if ( $string =~ /--debug/ ) {
        $debug = 1;
    }
}

my $testno = 0;

if ( scalar(@ARGV) > 0 ) {
    $rigno = $ARGV[0];
    $rigno =~ /(\d+)/;
    $rigno = $1;
}
&check_run($rigno);

if ( scalar(@ARGV) > 1 ) {
    $ttestno = $ARGV[1];
    $ttestno =~ /(\d+)/;
    $testno = $1;
}
### Find list of gasses to include in table ###
my @gaslist = split(/\s*\,\s*/,&AFM::get_usercv_test($rigno,$testno,'report','gas_names_ivtable'));
@gaslist = split(/\s*\,\s*/,&get_usercv($rigno,'report','gas_names_ivtable')) unless (@gaslist);
@gaslist = ('h2','ch4','o2','air','backup','sweep') unless (@gaslist);
my $voltlabel = 'cell_voltage';
my $templabel = 'T_center';

$homedir     = '/home/rig' . $rigno;
$currenttest = $testno;
$ivdir       =
  $AFM::publicdir . "rig" . $rigno . "/" . $rigno . "test"
  . $currenttest . "/iv";
print $ivdir, "\n" if ($debug);
$ivtable    = $ivdir . "/ivtable";
$ivavgtable = $ivdir . "/ivtable-avg";
$rmintable  = $ivdir . "/plotdata/rminvalues";
    for ($itype=1;$itype<3;$itype++)  {
	if ($itype==1){
latexsep()} else { 
htmlsep()}
;


open( HTML, "> $htmlfile" );

print HTML <<END;
<html>
<head>
<title>Plot</title>
</head>
<body>
<center>
END

open( HTMLTABLE, "> $htmltablefile" );

if ($latex) {
    print HTMLTABLE <<END;
\\documentclass[10pt]{article}
\\usepackage{fullpage, graphicx, url,dcolumn,rotating}
\\setlength{\\parskip}{1ex}
\\setlength{\\parindent}{0ex}
%\\setlength{\\textheight}{ 24cm}
\\setlength{\\tabcolsep}{ 1.0 mm}
\\pagestyle{empty}
\\newcolumntype{d}[1]{D{.}{.}{\#1}}
\\begin{document}

END
#    tex_table_heading();
}
else {
    print HTMLTABLE <<END;
<html>
<head>
<title>IV-table</title>
</head>
<body>
<table>
<table border>
<tbody>
END
}

$headingstring= heading();

open( IVTABLE,    $ivtable );
open( IVAVGTABLE, $ivavgtable );
open( RMINTABLE,  $rmintable );
$lineno = 0;

while (<IVTABLE>) {

    print HTML <<END;
<table>
<tbody>
END

if (($lineno % $nrowtable)==0 ) {

if ($lineno>0) {  tex_table_end ();};
 tex_table_heading();

}


    ++$lineno;
    print HTMLTABLE "\n";
    $rminline = <RMINTABLE>;
    @rminarr  = split ( ' ', $rminline );
    $rmin     = $rminarr[0];
    for my $key (keys %rmintabledata)
    {
	$rmintabledata{$key} = 0;
    }
    for ( $i = 1 ; $i < $#rminarr ; $i += 2 ) {

        $rmintabledata{ $rminarr[$i] } = $rminarr[ $i + 1 ];
    }
    $rfu = $rmintabledata{"ASR_corr"};

    $avg = <IVAVGTABLE>;
    print $_. $avg if ($debug);
    @Fld = split ( /\s+/, $_ . $avg, 9999 );

    for ( $i = 0 ; $i < $#Fld ; $i++ ) 
    {
        if ($Fld[$x] =~ /\w+/)
	{
	    $tabledata{ $Fld[$i] } = $Fld[ $i + 1 ];
	}
    }

    $htmlrow = $startrowsep;
    $htmlrow = $htmlrow . $startrow;

    $htmlrow = $htmlrow
      . $startseparator
      . $lineno
      . $endseparator . "\n"
      . $startseparator
      . $tabledata{"dstart"}
      . $endseparator;

    $pval = sprintf( "%.1f", ( $tabledata{"tstart"} ) );
    $htmlrow = $htmlrow . $startseparator . $pval . $endseparator;

    $pval =
      sprintf( "%.1f", ( $tabledata{"tstop"} - $tabledata{"tstart"} ) * 60 );

    $pval = sprintf( "%.1f", $tabledata{"cmax"} );
    $htmlrow = $htmlrow . $startseparator . $pval . $endseparator;

    $pval1 = sprintf( "%.1f", $tabledata{"tempavgup"} );

    $pval2 = sprintf( "%.1f", $tabledata{"tempavgdown"} );

    $ttype   = "td";
    $htmlrow =
      $htmlrow . $startseparator . ptable( $pval1, $pval2 ) . $endseparator;

    $pval1 = sprintf( "%.1f", $tabledata{"ocvavgup"} );

    $pval2 = sprintf( "%.1f", $tabledata{"ocvavgdown"} );

    $htmlrow =
      $htmlrow . $startseparator . ptable( $pval1, $pval2 ) . $endseparator;

    for (@gaslist)
    {
        $pval = sprintf( "%.1f", $tabledata{$_} );
        $htmlrow = $htmlrow . $startseparator . $pval . $endseparator;
    }

    $pval = sprintf( "%.3f", $rmin );
    $htmlrow = $htmlrow . $startseparator . $pval . $endseparator;
    $pval    = sprintf( "%.3f", $rfu );
    $htmlrow = $htmlrow . $startseparator . $pval . $endseparator . $endrow;

    print HTML "<H3>", $lineno, "</H3>\n";
    print HTML $startrow;
    print HTML "<td><a href=\"ivdatadir-" . $lineno
      . "/ivdata\"><img src=\"ivdatadir-"
      . $lineno
      . "/png/ivcurve.png\" alt=\"image\"></a></td>\n";
    print HTML "<td><a href=\"ivdatadir-" . $lineno
      . "/ivdata\"><img src=\"ivdatadir-"
      . $lineno
      . "/png/ivcurve-resistance.png\" alt=\"image\"></a></td>\n";
    print HTML "</tr></table><table><table border><tbody>";

    print HTML $headingstring, $htmlrow;
    print HTML "</table>";
    print HTML "<p>";

    print HTMLTABLE $htmlrow;
}
if ($latex) {
 tex_table_end ();
    print HTMLTABLE <<END;
\\end{document}
END
}
else {
    print HTMLTABLE <<END;
</tbody>
</table>
</center>
</body>
</html>
END
}

if ($latex) {
    $cstr =
      "cat        $htmltablefile  | sed 's#& \\\\# \\\\#g' > $htmltablefiletex";
    system($cstr);
}

}

sub heading {
    $res="";
    $res = $res . $startrow;
    $res = $res . $startseparator . $endseparator;
    $res = $res . $startseparator . "start date" . $endseparator;
    $res = $res
      . $startseparator
      . $beginmulti
      . ptable( "Time", "h" )
      . $endmulti
      . $endseparator;

    $res = $res
      . $startseparator
      . $beginmulti
      . ptable( "Max", "A" )
      . $endmulti
      . $endseparator;
    my $ltemp = $templabel;
    $ltemp =~ s/_/ /g;
    $res = $res
      . $startseparator
      . $beginmulti
      . ptable( ucfirst($ltemp), "start", "stop", $startsup . $deg . $endsup . "C" )
      . $endmulti
      . $endseparator;
    my $lvolt = $voltlabel;
    $lvolt =~ s/_/ /g;
    $res = $res
      . $startseparator
      . $beginmulti
      . ptable( ucfirst($lvolt), "start", "stop", "mV" )
      . $endmulti
      . $endseparator;
    for my $gas (@gaslist)
    {
	$gasst = ucfirst($gas);
	$gasst =~ s/_/ /g;
#	$gasst =~ s/_/\\_/g if ($beginmulti);
	$gasst =~ s/([a-zA-Z])(\d+)/\u$1$startsub$2$endsub/g;
	$res = $res
	    . $startseparator
	    . $beginmulti
	    . ptable( $gasst, $l_min )
	    . $endmulti
	    . $endseparator;
    }
    $res = $res
      . $startseparator
      . $beginmulti
      . ptable( "Rsec", "min", $omega . " cm" . $startsup . "2" . $endsup )
      . $endmulti
      . $endseparator;
    $res = $res
      . $startseparator
      . $beginmulti
      . ptable( "Rfu", $omega . " cm" . $startsup . "2" . $endsup )
      . $endmulti
      . $endseparator;
    $res = $res . $endrow;
    return $res;
}

sub ptable {
    local $localtable = $starttable;
    for (@_) {
        $localtable =
          $localtable . $startseparator . $_ . $endseparator . $endrow;
    }
    $localtable = $localtable . $endtable;
    return $localtable;
}

sub htmlsep {
    $latex=0;
    $htmltablefile = $ivdir . "/ivtable.html"; 
    $htmlfile   = $ivdir . "/ivcurves.html";
    $nrowtable=10000;
    $starttable = "\n  <table>\n";
    $endtable   = "  </table>\n";
    $beginmulti = "";
    $endmulti   = "";

    $ttype          = "td";
    $startrow       = "<tr align=center>\n";
    $startrowsep    = "";
    $startseparator = "<" . $ttype . ">";
    $endseparator   = "</" . $ttype . ">";
    $endrow         = "</tr>\n";
    $startsup       = "<sup>";
    $endsup         = "</sup>";
    $startsub       = "<sub>";
    $endsub         = "</sub>";
    $omega          = "&#937";
    $deg            = "o";
    $l_min          = "l/hour";
}

sub latexsep {
    $htmltablefile    = $ivdir . "/ivtable.txttex";
    $htmltablefiletex = $ivdir . "/ivtable.tex";
    $htmltablefileps  = $ivdir . "/ivtable.ps";
    $htmlfile   = "/dev/null";
    $nrowtable=12;
    $latex = 1;
    $html  = 0;

    $starttable     = "\n\\begin{tabular}{c}\n";
    $endtable       = "\\end{tabular}\n";
    $beginmulti     = "\\multicolumn {1}{c|} {";
    $endmulti       = "}";
    $startrowsep    = "\\hline\n";
    $startrow       = "";
    $startseparator = " ";
    $endseparator   = " & ";
    $endrow         = "\\\\\n";
    $startsup       = "\$^";
    $endsup         = "\$";
    $startsub       = "\$_";
    $endsub         = "\$";
    $omega          = "\$\\Omega\$";
    $deg            = "\\circ";
    $l_min          = "\$\\ell\$" . "/h";
}

sub tex_table_heading {
if ($latex) {
    my $str = '|d{1}' x scalar(@gaslist);
    print HTMLTABLE <<END;
\\begin{sidewaystable}
\\begin{tabular}{|c|c|d{1}|d{1}|d{1}|d{1}$str|d{3}|d{3}|}
\\hline
END
}
print HTMLTABLE $headingstring;

}

sub tex_table_end {
if ($latex) {
    print HTMLTABLE <<END;
\\hline
\\end{tabular}
\\end{sidewaystable}
END
}
}
